<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
   
    <title>AdminLTE 3 | Blank Page</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
   <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  </head>


  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
        </ul>

        <!-- Right navbar links -->
        <ul class="navbar-nav ml-auto">
          <!-- Navbar Search -->
          <li class="nav-item">
            <a
              class="nav-link"
              data-widget="navbar-search"
              href="#"
              role="button"
            >
              <i class="fas fa-search"></i>
            </a>
            <div class="navbar-search-block">
              <form class="form-inline">
                <div class="input-group input-group-sm">
                  <input
                    class="form-control form-control-navbar"
                    type="search"
                    placeholder="Search"
                    aria-label="Search"
                  />
                  <div class="input-group-append">
                    <button class="btn btn-navbar" type="submit">
                      <i class="fas fa-search"></i>
                    </button>
                    <button
                      class="btn btn-navbar"
                      type="button"
                      data-widget="navbar-search"
                    >
                      <i class="fas fa-times"></i>
                    </button>
                  </div>
                </div>
              </form>
            </div>
          </li>

          <!-- Messages Dropdown Menu -->
          <li class="nav-item dropdown">
            <a class="nav-link" data-toggle="dropdown" href="#">
              <i class="far fa-comments"></i>
              <span class="badge badge-danger navbar-badge">3</span>
            </a>
            <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user1-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 mr-3 img-circle"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      Brad Diesel
                      <span class="float-right text-sm text-danger"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">Call me whenever you can...</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user8-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 img-circle mr-3"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      John Pierce
                      <span class="float-right text-sm text-muted"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">I got your message bro</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user3-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 img-circle mr-3"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      Nora Silvester
                      <span class="float-right text-sm text-warning"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">The subject goes here</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item dropdown-footer"
                >See All Messages</a
              >
            </div>
          </li>
          <!-- Notifications Dropdown Menu -->
          <li class="nav-item dropdown">
            <a class="nav-link" data-toggle="dropdown" href="#">
              <i class="far fa-bell"></i>
              <span class="badge badge-warning navbar-badge">15</span>
            </a>
            <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
              <span class="dropdown-item dropdown-header"
                >15 Notifications</span
              >
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-envelope mr-2"></i> 4 new messages
                <span class="float-right text-muted text-sm">3 mins</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-users mr-2"></i> 8 friend requests
                <span class="float-right text-muted text-sm">12 hours</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-file mr-2"></i> 3 new reports
                <span class="float-right text-muted text-sm">2 days</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item dropdown-footer"
                >See All Notifications</a
              >
            </div>
          </li>
          <li class="nav-item">
            <a class="nav-link" data-widget="fullscreen" href="#" role="button">
              <i class="fas fa-expand-arrows-alt"></i>
            </a>
          </li>
          <li class="nav-item">
            <a
              class="nav-link"
              data-widget="control-sidebar"
              data-slide="true"
              href="#"
              role="button"
            >
              <i class="fas fa-th-large"></i>
            </a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8"
          />
          <span class="brand-text font-weight-light">Devcamp Admin</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/photo4.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Hung Tran</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    List of management
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="Question-CRUD.html" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Questions</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="Answer-CRUD.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Answers</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1><i>Test No.<span style="color: red;">J0403</span></i></h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Page</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <div class="container">
          <h2 style="text-align: center;"><b>Question management</b></h2>
          <div class="jumbotron container">
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="question-code">Question Code</label>
              </div>
              <div class="col-sm-9">
                <input type="number" id="input-question-code" name="question-code" placeholder="auto created/updated" disabled
                class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="question-content">Content of the question</label>
              </div>
              <div class="col-sm-9">
                <input type="text" id="input-question-content" name="question-content" placeholder="input content of question" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="mart">Mark of the question </label>
              </div>
              <div class="col-sm-9">
                <input  id="input-mark" name="mark" placeholder="input mark of the question" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="subject">Subject</label>
              </div>
              <div class="col-sm-9">
                <input type="text" id="input-subject" name="subject" placeholder="input name of the subject" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="create_date">Date of creation</label>
              </div>
              <div class="col-sm-9">
                <input type="date" date-date="" date-date-format="MM/DD/YYYY" id="input-createDate" name="created-date" class="form-control" disabled >
              </div>
            </div>
            
          <div class="col-sm-12" style="margin-left: 230px"	>
              <div class="row">
              <div class="col-sm-2 ">
                <button id="create_data" class="btn btn-success form-control"><i class="fa-solid fa-file-circle-plus"></i> Create</button>
              </div>
              <div class="col-sm-2">
                <button id="update_data" class="btn btn-info form-control"><i class="fa-solid fa-file-pen"></i> Update</button>
              </div>
              <div class="col-sm-2 ">
                <button id="clear_data" class="btn btn-warning  form-control"><i class="fa-solid fa-broom"></i> Clear form</button>
              </div>
              <div class="col-sm-2 ">
                <button id="delete_data" class="btn btn-danger form-control"><i class="fa-regular fa-trash-can"></i> Delete</button>
              </div>
              </div>
          </div>
          </div>
          <table class="table table-bordered table-striped table-hover" id="question-table">
            <thead>
              <tr>
                <th>Question code</th>
                <th>Content of the quesiton</th>
                <th>Mark of the quesiton</th>
                <th>Subject</th>
                <th>Date of creation</th>
              </tr>
            
          </table>
        </div>
        <!-- /.content -->
      </div>
      <!-- Delete confirm modal -->
      <div>
        <div class="modal fade" tabindex="-1" id="delete-modal">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-body bg-warning">
                <h3>Are you sure to delete this question?</h3>
                <div class="text-right">
                  <button class="btn btn-danger" id="btn-confirm-delete">Confirm</button>
                  <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
              </div>
              
            </div>
          </div>
        </div>
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 3.2.0</div>
        <strong
          >Copyright &copy; 2023
          <a href="https://adminlte.io">AdminLTE.io</a>.</strong
        >
        All rights reserved.
      </footer>

      <!-- Control Sidebar -->
      <aside class="control-sidebar control-sidebar-dark">
        <!-- Control sidebar content goes here -->
      </aside>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->
  </body>
    
   
    <!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<!-- AdminLTE dashboard demo (This is only for demo purposes) -->
<script src="dist/js/pages/dashboard.js"></script>

<!-- Main functions -->
<script>

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  
    var gNameCol = ["id", "noiDungCauHoi", "diemMoiCauHoi", "monHoc", "ngayTao"]
  
    const gCOL_ID = 0;
    const gCOL_CONTENT = 1;
    const gCOL_MARK = 2;
    const gCOL_SUBJECT = 3;
    const gCOL_CREATE_DATE = 4;
        
    var gRowData;
    var gRowId;
    var gStt = 0; 
    var gQuestionTable = $("#question-table").DataTable({
        columns: [
          {data: gNameCol[gCOL_ID]},
          {data: gNameCol[gCOL_CONTENT]},
          {data: gNameCol[gCOL_MARK]},
          {data: gNameCol[gCOL_SUBJECT]},
          {data: gNameCol[gCOL_CREATE_DATE]},
          
        ],
        columnDefs: [
        {
          targets: gCOL_ID, 
          className: "text-center",
        },
        {
          targets: gCOL_MARK, 
          className: "text-center",
        },
        
        {
          targets: gCOL_CREATE_DATE, 
          className: "text-center",
        },
        {
          targets: gCOL_SUBJECT,
          className: "text-primary text-center",
        }]
      })
  
   /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
   
   
   $(document).ready(function(){
    $("#input-createDate").prop("disabled", false);
    //load data to the table
    callAPIGetData();

    //add event for CREATE Button click
    $("#create_data").on('click', function(){
      onBtnCreateClick();
    });
  
    //add event of row click
    $("#question-table").on("click", "tr", function(){
      eventOnRowClick(this);
    })
  
    //add event for UPDATE Button click
    $("#update_data").on('click', function(){
      onBtnUpdateClick();
    })

    //add event for CLEAR Button click
    $("#clear_data").on('click', function(){
      clearTheForm();
    })
    
    //add event for DELETE Button click 
    $("#delete_data").on('click', function(){
      onBtnDeleteClick();
    })

    //add event for Delete confirm click
    $("#btn-confirm-delete").on('click', function(){
      onBtnDeleteConfirm();
    })

  })
  
  
   /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
  function eventOnRowClick(paramRow){

    gRowData = getRowData(paramRow);
    gRowId = gRowData.id;
    console.log("Row_Id: " + gRowId);
    
    $("#input-createDate").prop("disabled", true);
    loadDataToForm(gRowData);
  }
  
  function onBtnCreateClick(){
  
    //create object for data update
    var vCreateObj = {
      noiDungCauHoi:"",
      diemMoiCauHoi:"",
      monHoc:"",
      ngayTao:"",
      
    };
  
    //get data from the form
    getDataFromTheForm(vCreateObj);
    console.log(vCreateObj);
  
    //validate the data
    var vValidRes = validateData(vCreateObj);
    console.log(vCreateObj);

    //call API to update the data to server
    if (vValidRes){
      console.log("ID " + gRowId);
      callApiCreateData(vCreateObj);
    }
  }
  
  function onBtnUpdateClick(){
    //create object for data update
    var vUpdateObj = {
      noiDungCauHoi:"",
      diemMoiCauHoi:"",
      monHoc:"",
    };
  
    //get data from the form
    getDataForUpdate(vUpdateObj);
    console.log(vUpdateObj);
  
    //validate the data
    var vValidRes = validateData(vUpdateObj);
    console.log(vUpdateObj);

    //call API to update the data to server
    if (vValidRes){
      console.log("ID " + gRowId);
      callApiUpdateData(vUpdateObj);
    }
  }

  function onBtnDeleteClick(){
    $("#delete-modal").modal("show");
  }
    
  function onBtnDeleteConfirm(){
    $.ajax({
        url: "http://localhost:8080/delete-question/" + gRowId,
        type: "DELETE",
        success: function(res){
          console.log(res);
          $("#delete-modal").modal("hide");
          callAPIGetData();
          clearTheForm();
          //alert("The question has been DELETED successfully !!!");
        },
        error: function(err){
          console.log(err.response);
        }
      })
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
  function callAPIGetData (){
    $.ajax({
        url: "http://localhost:8080/all-question",
        type: "GET",
        dataType: "json",
        success: function(res){
          console.log(res);
          reLoadTable(res);
        },
        error: function(err){
          alert(err.responseText);
        }
      })
   }
  
  function reLoadTable(paramData){
    
    gQuestionTable.clear();
    gQuestionTable.rows.add(paramData);
    gQuestionTable.draw();
  }
  
  function getRowData(paramData){
    //var vTableRow = $(paramButton).parents("tr");
    var vRowData = gQuestionTable.row(paramData).data();
    console.log("Row_Data:" + vRowData);
  
    return vRowData;
  }
  
  function loadDataToForm(paramRowData){
    $("#input-question-code").val(paramRowData.id);
    $("#input-question-content").val(paramRowData.noiDungCauHoi);
    $("#input-mark").val(paramRowData.diemMoiCauHoi);
    $("#input-createDate").val(paramRowData.ngayTao);
    $("#input-subject").val(paramRowData.monHoc);
  }
  
  function getDataFromTheForm(paramData){
    paramData.noiDungCauHoi = $("#input-question-content").val();
    paramData.diemMoiCauHoi = $("#input-mark").val();
    paramData.monHoc = $("#input-subject").val();
    paramData.ngayTao = $("#input-createDate").val();
  }

  function getDataForUpdate(paramData){
    paramData.noiDungCauHoi = $("#input-question-content").val();
    paramData.diemMoiCauHoi = $("#input-mark").val();
    paramData.monHoc = $("#input-subject").val();
  }
    
  function validateData(paramValid){
    if (paramValid.noiDungCauHoi == ""){
      alert("Question content is empty !!!");
      return false;
    }
    if (paramValid.diemMoiCauHoi == ""){
      alert("Mark is empty !!!");
      return false;
    }
    if (isNaN(paramValid.diemMoiCauHoi) === true ){
      alert("Mark must be number !!!");
      return false;
    }
    if (1> paramValid.diemMoiCauHoi || paramValid.diemMoiCauHoi >10){
      alert("Mark must be from 1 to 10 !!!");
      return false;
    }
    if (paramValid.monHoc == ""){
      alert("Subject is empty !!!");
      return false;
    }
    if (paramValid.ngayTao == ""){
      alert("Date of creation is empty!!!");
      return false;
    }
        
    var currentDate = new Date();
    var dateString = new Date(currentDate.getTime() - (currentDate.getTimezoneOffset() * 60000 ))
                    .toISOString()
                    .split("T")[0]; 
    console.log(currentDate);
    console.log(dateString);
    console.log(paramValid.ngayTao);

    var ngayTao = paramValid.ngayTao;

    var day1 = new Date(dateString); 
    var day2 = new Date(ngayTao);

    var diff = Math.abs(day1 - day2);
    var d = diff/(1000 * 3600 * 24);
    console.log(d);

    if (d > 0){
      alert("Date of creation must be the current date or before !!!");
      return false;
    }
    return true;
  }
  
  function callApiCreateData(paramData){
    $.ajax({
        url: "http://localhost:8080/create-question",
        type: "POST",
        contentType: "application/json",
        data: JSON.stringify(paramData),
        success: function(res){
          console.log(res);
          callAPIGetData();
          clearTheForm();
          alert("The question of ID - " + res.id + " has been CREATED successfully !!!");
  
        },
        error: function(err){
          alert(err.responseText);
        }
      })
  }

  function callApiUpdateData(paramData){
    $.ajax({
        url: "http://localhost:8080/update-question/" + gRowId,
        type: "PUT",
        contentType: "application/json",
        data: JSON.stringify(paramData),
        success: function(res){
          console.log(res);
          callAPIGetData();
          clearTheForm();
          alert("The question of ID - " + res.id + " has been UPDATED successfully !!!");
        },
        error: function(err){
          alert(err.responseText);
        }
      })
  }
  
  function clearTheForm(){
    $("#input-createDate").prop("disabled", false);

    $("#input-question-code").val("");
    $("#input-question-content").val("");
    $("#input-mark").val("");
    $("#input-subject").val("");
    $("#input-createDate").val("");
    
  }
  
  </script>   

</html>
